#ifndef LUA_STATIC_H
#define LUA_STATIC_H

extern "C"
{
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
};

#include "unicode_converter.h"

class Lua
{
    public:
        Lua();
        virtual ~Lua();

        void register_func(char*, int (*) (lua_State*));
        void register_lib(const char*, const luaL_Reg*);

        bool dofile(const wchar_t*);
        bool pcall(int, int);

        void getglobal(const char*);
        void pushstring(const char*);
        void pushnil();
        bool isfunction(int);

    private:
        lua_State *L;
};

#endif // LUA_STATIC_H
