#include "filemanager.h"

FileManager::FileManager()
{
    LPWSTR *argv;
    int argc;
    argv = CommandLineToArgvW(GetCommandLineW(), &argc);
    if (argc < 1)
        throw "Invalid program execution!";

    for (int i = 0; i<argc; i++)
    {
        wstring arg(argv[i]);
        if (arg.length() > 4)
        {
            if (i==0)
                path = arg.substr(0, arg.find_last_of('\\')+1);
            else if (arg.substr(arg.length()-4) == L".ass")
                kt = arg;
            else if (arg.substr(arg.length()-4) == L".lua")
                fx = arg;
        }
    }

    if(!fx.empty())
    {
        wstring fx_path = fx.substr(0, fx.find_last_of('\\')+1);
        fx_path.append(L"Kara-FX.ass");
        final = fx_path;
    }
}

wchar_t* FileManager::get_file_dialog(GUI *wnd, wchar_t *title, wchar_t *filter, wchar_t *extension)
{
    wchar_t *file = new wchar_t[MAX_FILE_SIZE];
    file[0] = L'\0';

    OPENFILENAMEW ofn;
    ofn.lStructSize = sizeof(OPENFILENAMEW);
    ofn.hwndOwner = wnd->hwnd;
    ofn.hInstance = wnd->instance;
    ofn.lpstrFilter = filter;
    ofn.lpstrCustomFilter = 0;
    ofn.nMaxCustFilter = 0;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = file;
    ofn.nMaxFile = MAX_FILE_SIZE;
    ofn.lpstrFileTitle = 0;
    ofn.nMaxFileTitle = MAX_FILE_SIZE;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrTitle = title;
    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.nFileOffset = 0;
    ofn.nFileExtension = 0;
    ofn.lpstrDefExt = extension;
    ofn.lCustData = 0;
    ofn.lpfnHook = 0;
    ofn.lpTemplateName = 0;

    if(GetOpenFileNameW(&ofn))
        return file;
    else
    {
        delete (file);
        return NULL;
    }
}

wchar_t* FileManager::set_file_dialog(GUI *wnd, wchar_t *title, wchar_t *filter, wchar_t *extension)
{
    wchar_t *file = new wchar_t[MAX_FILE_SIZE];
    file[0] = L'\0';

    OPENFILENAMEW ofn;
    ofn.lStructSize = sizeof(OPENFILENAMEW);
    ofn.hwndOwner = wnd->hwnd;
    ofn.hInstance = wnd->instance;
    ofn.lpstrFilter = filter;
    ofn.lpstrCustomFilter = 0;
    ofn.nMaxCustFilter = 0;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = file;
    ofn.nMaxFile = MAX_FILE_SIZE;
    ofn.lpstrFileTitle = 0;
    ofn.nMaxFileTitle = MAX_FILE_SIZE;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrTitle = title;
    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.nFileOffset = 0;
    ofn.nFileExtension = 0;
    ofn.lpstrDefExt = extension;
    ofn.lCustData = 0;
    ofn.lpfnHook = 0;
    ofn.lpTemplateName = 0;

    if(GetSaveFileNameW(&ofn))
        return file;
    else
    {
        delete (file);
        return NULL;
    }
}
