#include "gui.h"

const char classname[] = "NyuFX";
const int wndWidth = 400, wndHeight = 450;

GUI::GUI(HINSTANCE hThisInstance, LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM)) : instance(hThisInstance)
{
    if ( FindWindow(classname, classname) )
        throw "Program is currently running!";

    wincl.hInstance = instance;
    wincl.lpszClassName = classname;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon(instance, MAKEINTRESOURCE(IDI_APP_ICON));
    wincl.hIconSm = LoadIcon(instance, MAKEINTRESOURCE(IDI_APP_ICON));
    wincl.hCursor = LoadCursor (NULL, IDC_HAND);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH)(GetStockObject(WHITE_BRUSH));

    if (!RegisterClassExA (&wincl))
        throw "One instance of NyuFX is currently running!";

    InitCommonControls();

    //Windows
    hwnd = CreateWindowEx(WS_EX_CLIENTEDGE,
                          classname,
                          classname,
                          WS_VISIBLE | WS_CAPTION | WS_MINIMIZEBOX| WS_OVERLAPPED | WS_SYSMENU,
                          GetSystemMetrics(SM_CXSCREEN) / 2 - wndWidth / 2 , GetSystemMetrics(SM_CYSCREEN) / 2 - wndHeight / 2,
                          wndWidth, wndHeight,
                          HWND_DESKTOP,
                          NULL,
                          instance,
                          NULL);

    if(!hwnd)
        throw "Couldn't create window!";

    kt_edit = CreateWindowExW(WS_EX_CLIENTEDGE, L"EDIT", NULL, WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL, 10, 175, 290, 20, hwnd, NULL, instance, NULL);
    kt_button = CreateWindow("BUTTON", "ASS FILE", WS_VISIBLE | WS_CHILD, 302, 175, 80, 20, hwnd, (HMENU)ID_KTIME_BUTTON, instance, NULL);
    fx_edit = CreateWindowExW(WS_EX_CLIENTEDGE, L"EDIT", NULL, WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL, 10, 200, 290, 20, hwnd, NULL, instance, NULL);
    fx_button = CreateWindow("BUTTON", "LUA FILE", WS_VISIBLE | WS_CHILD, 302, 200, 80, 20, hwnd, (HMENU)ID_FX_BUTTON, instance, NULL);
    final_edit = CreateWindowExW(WS_EX_CLIENTEDGE, L"EDIT", NULL, WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL, 10, 225, 290, 20, hwnd, NULL, instance, NULL);
    final_button = CreateWindow("BUTTON", "OUTPUT FILE", WS_VISIBLE | WS_CHILD, 302, 225, 80, 20, hwnd, (HMENU)ID_FINAL_BUTTON, instance, NULL);
    progressbar = CreateWindow(PROGRESS_CLASS, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER, 10, 260, 370, 20, hwnd, NULL, instance, NULL);
    log = CreateWindowExW(WS_EX_CLIENTEDGE, L"EDIT", NULL,WS_VISIBLE | WS_CHILD | ES_READONLY | ES_AUTOVSCROLL | ES_MULTILINE | WS_VSCROLL | WS_BORDER,
                                       10, 295, 370, 70, hwnd, NULL, instance, NULL);
    execute_button = CreateWindow("BUTTON", "Execute", WS_VISIBLE | WS_CHILD, 10, 372, 200, 20, hwnd, (HMENU)ID_EXECUTE_BUTTON, instance, NULL);

    SendMessageW(kt_edit, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessage(kt_button, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessageW(fx_edit, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessage(fx_button, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessageW(final_edit, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessage(final_button, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessage(progressbar, PBM_SETRANGE, 0, MAKELPARAM(0, 100));
    SendMessage(progressbar, PBM_SETPOS, 0, 0);
    SendMessageW(log, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);
    SendMessage(execute_button, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), TRUE);

    SetFocus(kt_edit);

    //Menu
    hmenuMain = CreateMenu();
    hmenuProg = CreatePopupMenu();
    hmenuInfo = CreatePopupMenu();
    hmenuHelp = CreatePopupMenu();

    AppendMenu(hmenuMain, MF_STRING | MF_POPUP, (UINT) hmenuProg, "Program");
    AppendMenu(hmenuMain, MF_STRING | MF_POPUP, (UINT) hmenuInfo, "Info");

    AppendMenu(hmenuProg, MF_STRING, ID_RESET, "Reset");
    AppendMenu(hmenuProg, MF_STRING, ID_CLOSE, "Exit");

    AppendMenu(hmenuInfo, MF_STRING | MF_POPUP, (UINT) hmenuHelp, "Help");
    AppendMenu(hmenuHelp, MF_STRING, ID_CMDS, "Commands");
    AppendMenu(hmenuHelp, MF_STRING, ID_VALS, "Values");
    AppendMenu(hmenuHelp, MF_STRING, ID_LUA, "Lua");
    AppendMenu(hmenuInfo, MF_STRING, ID_ABOUT, "About");

    SetMenu(hwnd, hmenuMain);

    //Font for painting
    font = CreateFont(18, 0, 0 ,0 , 900, false, false, false, DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, FF_DONTCARE, (char*)"Times New Roman");
}

GUI::~GUI()
{
    //Menu
    DestroyMenu(hmenuHelp);
    DestroyMenu(hmenuInfo);
    DestroyMenu(hmenuProg);
    DestroyMenu(hmenuMain);
    //Windows
    DestroyWindow(final_edit);
    DestroyWindow(final_button);
    DestroyWindow(fx_edit);
    DestroyWindow(fx_button);
    DestroyWindow(kt_edit);
    DestroyWindow(kt_button);
    DestroyWindow(progressbar);
    DestroyWindow(log);
    DestroyWindow(execute_button);
    DestroyWindow(hwnd);
    //Font
    DeleteObject(font);
    //Class
    UnregisterClass(classname, instance);
}

void GUI::paint()
{
    PAINTSTRUCT ps;
    HDC hdc, hdcMem;
    hdc = BeginPaint(hwnd, &ps);

    hdcMem = CreateCompatibleDC(hdc);
    SelectObject(hdcMem, LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_APP_BKIMG)));
    BitBlt(hdc, 0, 0, 400, 200, hdcMem, 0, 0, SRCCOPY);
    DeleteDC(hdcMem);

    SelectObject(hdc, font);
    SetBkMode(hdc, TRANSPARENT);
    SetTextColor(hdc, RGB(0,0,255));
    TextOut(hdc, 320, 150, "by Youka", 8);

    EndPaint(hwnd, &ps);
}

void GUI::reset()
{
    SendMessageW(kt_edit, WM_SETTEXT, 0, (LPARAM)L"");
    SendMessageW(fx_edit, WM_SETTEXT, 0, (LPARAM)L"");
    SendMessageW(final_edit, WM_SETTEXT, 0, (LPARAM)L"");
    SendMessage(progressbar, PBM_SETPOS, 0, 0);
    SendMessageW(log, WM_SETTEXT, 0, (LPARAM)L"");
}

void GUI::enable(bool w)
{
    SendMessage(kt_edit, EM_SETREADONLY, !w, 0);
    SendMessage(fx_edit, EM_SETREADONLY, !w, 0);
    SendMessage(final_edit, EM_SETREADONLY, !w, 0);

    EnableWindow(kt_button, w);
    EnableWindow(fx_button, w);
    EnableWindow(final_button, w);
    if(w)
        SendMessage(execute_button, WM_SETTEXT, 0, (LPARAM)"Execute");
    else
        SendMessage(execute_button, WM_SETTEXT, 0, (LPARAM)"Cancel");
}

bool GUI::active()
{
    return IsWindowEnabled(kt_button);
}

wchar_t** GUI::get_edit()
{
    int kt_len, fx_len, final_len;
    kt_len = GetWindowTextLengthW(kt_edit) + 1;
    fx_len = GetWindowTextLengthW(fx_edit) + 1;
    final_len = GetWindowTextLengthW(final_edit) + 1;

    wchar_t **fields = new wchar_t*[3];
    fields[0] = new wchar_t[kt_len];
    fields[1] = new wchar_t[fx_len];
    fields[2] = new wchar_t[final_len];

    GetWindowTextW(kt_edit, fields[0], kt_len);
    GetWindowTextW(fx_edit, fields[1], fx_len);
    GetWindowTextW(final_edit, fields[2], final_len);

    return fields;
}

void GUI::set_edit(wchar_t *kt, wchar_t *fx, wchar_t *final)
{
    if (kt != NULL)
        SendMessageW(kt_edit, WM_SETTEXT, 0, (LPARAM)kt);
    if (fx != NULL)
        SendMessageW(fx_edit, WM_SETTEXT, 0, (LPARAM)fx);
    if (final != NULL)
        SendMessageW(final_edit, WM_SETTEXT, 0, (LPARAM)final);
}

void GUI::set_progressbar(int status)
{
    SendMessage(progressbar, PBM_SETPOS, (WPARAM)status, 0);
}

void GUI::log_append(wchar_t *text)
{
    if (wcslen(text) > MAX_LOG_SIZE)
        return;

    int log_len = GetWindowTextLengthW(log) + 1;
    wchar_t *p_log = new wchar_t[log_len];
    GetWindowTextW(log, p_log, log_len);
    wstring temp_log = wstring(p_log); delete (p_log);
    temp_log = wstring(text) + wstring(L"\r\n") + temp_log;

    unsigned int result_len = temp_log.length();
    if (result_len > MAX_LOG_SIZE)
    {
        unsigned int overflow = result_len - MAX_LOG_SIZE;
        temp_log = temp_log.substr(overflow, result_len);
    }

    SendMessageW(log, WM_SETTEXT, 0, (LPARAM)temp_log.c_str());
}
