#ifndef GUI_H
#define GUI_H

#include "resource.h"
#include <commctrl.h>
#include <string>
using namespace std;

//LOG SIZE
#define MAX_LOG_SIZE 8000

//MENU
#define ID_RESET 100
#define ID_CLOSE 101
#define ID_ABOUT 200
#define ID_CMDS 201
#define ID_VALS 202
#define ID_LUA 203

//BUTTONS
#define ID_KTIME_BUTTON 300
#define ID_FX_BUTTON 301
#define ID_FINAL_BUTTON 302
#define ID_EXECUTE_BUTTON 303

class GUI
{
    public:
        friend class FileManager;

        GUI(HINSTANCE, LRESULT CALLBACK (HWND, UINT, WPARAM, LPARAM));
        virtual ~GUI();

        void paint();
        void reset();
        void enable(bool);
        bool active();
        wchar_t** get_edit();
        void set_edit(wchar_t*, wchar_t*, wchar_t*);
        void set_progressbar(int);
        void log_append(wchar_t*);

    private:
        HINSTANCE instance;
        WNDCLASSEX wincl;
        HFONT font;
        HMENU hmenuMain, hmenuProg, hmenuInfo, hmenuHelp;

        HWND hwnd, kt_edit, fx_edit, final_edit, progressbar, log, kt_button, fx_button, final_button, execute_button;
};

#endif // GUI_H
