#ifndef LUAENV_H
#define LUAENV_H

#include "Lua.h"
#include "gui.h"
#include "picopng.h"

typedef struct ASSStyle{
    wchar_t fontname[32];
    unsigned int fontsize;
    bool bold;
    bool italic;
    bool underline;
    bool strikeout;
    double scale_x;
    double scale_y;
    unsigned int spacing;
    short encoding;
}ASSStyle;

typedef struct TXTExt{
   double width, height, ascent, descent, internal_lead, external_lead;
}TXTExt;

typedef struct{
    GUI *wnd;
    string output;
    unsigned long int line_count;
}Proc_Info;
extern Proc_Info pi;

#define SCALE_FACTOR 8
#define IMPLENT(func) int l_##func (lua_State *L)

IMPLENT(progress);
IMPLENT(print);
IMPLENT(writefile);
IMPLENT(TextExtents);
IMPLENT(GetImage);
IMPLENT(GetPathW);
IMPLENT(GetPixelsW);

#endif // LUAENV_H
