function sub(line)
	local l = table.copy(line)

	l.start_time = line.start_time - 400
	l.end_time = line.end_time + 400
	l.text = "{\\blur3\\fad(400,400)}" .. line.text
	Output(l)
end

function roumaji(line)
	local l = table.copy(line)

	for si, syl in ipairs(line.syls) do
		syl.mid_time = syl.start_time + syl.duration / 2
		l.text = string.format("{\\an5\\pos(%.3f,%.3f)\\t(%d,%d,\\fscy150)\\t(%d,%d,\\fscy100)}%s", syl.center, syl.middle, syl.start_time, syl.mid_time, syl.mid_time, syl.end_time, syl.text)
		Output(l)
	end
end

function kanji(line)
	local l = table.copy(line)

	for ci, char in ipairs(line.chars) do
		if char.text ~= " " then
			char.mid_time = char.start_time + char.duration / 2
			l.text = string.format("{\\an5\\pos(%.3f,%.3f)\\t(%d,%d,\\fscx150)\\t(%d,%d,\\fscx100)}%s", char.center, char.middle, char.start_time, char.mid_time, char.mid_time, char.end_time, char.text)
			Output(l)
		end
	end
end

function main()
	for li, line in ipairs(lines) do
		if line.styleref.alignment >=7 then
			roumaji(line)
		elseif line.styleref.alignment <=3 then
			sub(line)
		else
			kanji(line)
		end
		ProgressStatus(li / #lines)
	end
	print("Writing output file...")
end

main()
