function sub(line)
	local l = table.copy(line)

	l.start_time = line.start_time - line.infade/2
	l.end_time = line.end_time + line.outfade/2
	l.text = string.format("{\\blur3\\fad(%d,%d)}%s", line.infade/2, line.outfade/2, line.text)
	Output(l)
end

function roumaji(line)
	local l = table.copy(line)

	--infade
	l.start_time = line.start_time - line.infade/2
	l.end_time = line.start_time
	for wi, word in ipairs(line.words) do
		local x1, y1 = word.x + math.random(-20, 20), word.y + math.random(-20, 20)
		local x2, y2 = word.x, word.y
		local frx, fry, frz = math.random(-180, 180), math.random(-180, 180), math.random(-180, 180)
		l.text = string.format("{\\fad(%d,0)\\move(%.3f,%.3f,%.3f,%.3f)\\frx%d\\fry%d\\frz%d\\t(\\frx0\\fry0\\frz0)}%s", line.infade/2, x1, y1, x2, y2, frx, fry, frz, word.text)
		Output(l)
	end

	--outfade
	l.start_time = line.end_time
	l.end_time = line.end_time + line.outfade/2
	for wi, word in ipairs(line.words) do
		local x1, y1 = word.x, word.y
		local x2, y2 = word.x + math.random(-20, 20), word.y + math.random(-20, 20)
		local frx, fry, frz = math.random(-180, 180), math.random(-180, 180), math.random(-180, 180)
		l.text = string.format("{\\fad(0,%d)\\move(%.3f,%.3f,%.3f,%.3f)\\t(\\frx%d\\fry%d\\frz%d)}%s", line.outfade/2, x1, y1, x2, y2, frx, fry, frz, word.text)
		Output(l)
	end

	--nothing doing sylables
	l.start_time = line.start_time
	for si, syl in ipairs(line.syls) do
		l.end_time = line.start_time + syl.start_time
		l.text = string.format("{\\pos(%.3f,%.3f)}%s", syl.x, syl.y, syl.text)
		Output(l)
	end
	l.end_time = line.end_time
	for si, syl in ipairs(line.syls) do
		l.start_time = line.start_time + syl.end_time
		l.text = string.format("{\\pos(%.3f,%.3f)}%s", syl.x, syl.y, syl.text)
		Output(l)
	end

	--sylables effect
	for si, syl in ipairs(line.syls) do
		for s, e, i, n in frames(line.start_time + syl.start_time, line.start_time + syl.end_time, 41.71) do
			l.start_time = s
			l.end_time = e
			local x, y = syl.x + math.random(-3,3), syl.y + math.random(-3,3)
			l.text = string.format("{\\pos(%.3f,%.3f)}%s", x, y, syl.text)
			Output(l)
		end
	end
end

function kanji(line)
	local l = table.copy(line)

	--infade
	l.start_time = line.start_time - line.infade/2
	l.end_time = line.start_time
	for ci, char in ipairs(line.chars) do
		local x1, y1 = char.x + math.random(-20, 20), char.y + math.random(-20, 20)
		local x2, y2 = char.x, char.y
		local frx, fry, frz = math.random(-180, 180), math.random(-180, 180), math.random(-180, 180)
		l.text = string.format("{\\fad(%d,0)\\move(%.3f,%.3f,%.3f,%.3f)\\frx%d\\fry%d\\frz%d\\t(\\frx0\\fry0\\frz0)}%s", line.infade/2, x1, y1, x2, y2, frx, fry, frz, char.text)
		Output(l)
	end

	--outfade
	l.start_time = line.end_time
	l.end_time = line.end_time + line.outfade/2
	for ci, char in ipairs(line.chars) do
		local x1, y1 = char.x, char.y
		local x2, y2 = char.x + math.random(-20, 20), char.y + math.random(-20, 20)
		local frx, fry, frz = math.random(-180, 180), math.random(-180, 180), math.random(-180, 180)
		l.text = string.format("{\\fad(0,%d)\\move(%.3f,%.3f,%.3f,%.3f)\\t(\\frx%d\\fry%d\\frz%d)}%s", line.outfade/2, x1, y1, x2, y2, frx, fry, frz, char.text)
		Output(l)
	end

	--nothing doing sylables
	l.start_time = line.start_time
	for ci, char in ipairs(line.chars) do
		l.end_time = line.start_time + char.start_time
		l.text = string.format("{\\pos(%.3f,%.3f)}%s", char.x, char.y, char.text)
		Output(l)
	end
	l.end_time = line.end_time
	for ci, char in ipairs(line.chars) do
		l.start_time = line.start_time + char.end_time
		l.text = string.format("{\\pos(%.3f,%.3f)}%s", char.x, char.y, char.text)
		Output(l)
	end

	--sylables effect
	for ci, char in ipairs(line.chars) do
		for s, e, i, n in frames(line.start_time + char.start_time, line.start_time + char.end_time, 41.71) do
			l.start_time = s
			l.end_time = e
			local x, y = char.x + math.random(-3,3), char.y + math.random(-3,3)
			l.text = string.format("{\\pos(%.3f,%.3f)}%s", x, y, char.text)
			Output(l)
		end
	end
end

function main()
	for li, line in ipairs(lines) do
		if line.styleref.alignment >=7 then
			roumaji(line)
		elseif line.styleref.alignment <=3 then
			sub(line)
		else
			kanji(line)
		end
		ProgressStatus(li / #lines)
	end
	print("Writing output file...")
end

main()
