function roumaji_w(line)
	local l = table.copy(line)

	--infade
		--fade black&white
	l.layer = 1
	l.start_time = line.start_time - line.infade/2
	l.end_time = line.start_time + 100
	local line_path = GetPath(line.text, line.styleref)
	line_path:move(line.left, line.top, 0)
	local rect = Rectangle(line.width/2, line.height)
	for i = 1, 2 do
		if i == 2 then line_path:tooutline(line.styleref.outline) end
		l.text = string.format("{\\clip(4,%s)\\an7\\move(%.3f,%.3f,%.3f,%.3f,0,%d)\\fad(0,100)\\1c&HFFFFFF&\\3c&HFFFFFF&\\bord%.1f\\blur5\\p1}%s",
								line_path:tostring(), line.left-line.width/2, line.top, line.left, line.top, line.infade/2, line.styleref.outline*2, rect)
		Output(l)
		l.text = string.format("{\\clip(4,%s)\\an7\\move(%.3f,%.3f,%.3f,%.3f,0,%d)\\fad(0,100)\\1c&H000000&\\3c&H000000&\\bord%.1f\\blur5\\p1}%s",
								line_path:tostring(), line.right, line.top, line.right-line.width/2, line.top, line.infade/2, line.styleref.outline*2, rect)
		Output(l)
	end
		--star rays
	for ray_i = 1, 2 do
		local color = ray_i==1 and "&H000000&" or "&HFFFFFF&"
		local z_direction = math.randomway()
		local curve_points = {
			{line.left, line.top + math.random(0, line.height), z_direction},
			{line.center + math.random(line.width, line.width*2), line.middle + math.random(-line.height, line.height), 0},
			{line.center + math.random(-line.width*2, -line.width), line.middle + math.random(-line.height, line.height), 0},
			{line.right, line.top + math.random(0, line.height), -z_direction}
		}
		for s, e, i, n in frames(line.start_time - line.infade/2, line.start_time + 400, 41.71 / 10) do
			l.start_time = s
			l.end_time = s + 400
			for glance_i = 1, 6 do
				local pct = i / n
				local point = math.bezier(pct, curve_points)
				local spread = math.round(point[3] * 4)
				local glance, border = Glance(4, 0, 9+spread), spread / 4
				local x1, y1 = point[1] + math.random(-6+spread,6+spread), point[2] + math.random(-6+spread,6+spread)
				local x2, y2 = point[1], point[2]
				l.layer = point[3] < 0 and 0 or 1
				l.text = string.format("{\\fad(100,300)\\an5\\move(%.3f,%.3f,%.3f,%.3f)\\1c%s\\3c%s\\bord%.1f\\blur2\\p1}%s", x1, y1, x2, y2, color, color, border, glance)
				Output(l)
			end
		end
	end

	--basic + outfade
	l.layer = 0
	l.start_time = line.start_time
	l.end_time = line.end_time + line.outfade/2
	l.text = string.format("{\\pos(%.3f,%.3f)\\fad(0,%d)\\t(%d,%d,\\1c&HFFFFFF&\\3c&HFFFFFF&\\bord%.1f\\blur3)}%s",
							line.x, line.y, line.outfade/4, line.duration, line.duration + line.outfade/4, line.styleref.outline*2, line.text)
	Output(l)

	--sylables effect
	local arc = Ellipse(10,10)
	for si, syl in ipairs(line.syls) do
		local syl_path = GetPath(syl.text, line.styleref)
		syl_path:split(2)
		local fx_dur = syl.duration * 0.35
		local function outline_fx(point, i, n)
			l.start_time = line.start_time + syl.start_time + i/n * syl.duration * 0.65
			l.end_time = l.start_time + fx_dur
			local x, y = syl.left + point[1]/8, syl.top + point[2]/8
			l.text = string.format("{\\fad(%d,%d)\\1c&HFFFFFF&\\bord0\\blur1\\an5\\pos(%.3f,%.3f)\\p2}%s", fx_dur/3, fx_dur*2/3, x, y, arc)
			Output(l)
		end
		syl_path:filter(outline_fx)
	end
end

function roumaji_m(line)
	local l = table.copy(line)

	--basic
	local in_out_fade = 200
	for s, e, i, n in frames(line.start_time - in_out_fade, line.end_time + in_out_fade, 41.71) do
		l.start_time = s
		l.end_time = e
		local line_path = GetPath(line.text, line.styleref)
		line_path:move(line.left-200 + 400 * (i/n), line.top+line.height, 0)
		line_path:split(3)
		local function wave(point)
			point[2] = point[2] + math.sin(point[1]/80) * line.height
		end
		line_path:filter(wave)
		l.text = string.format("{\\pos(0,0)\\an7\\p4}%s", line_path:tostring())
		if s < line.start_time then
			local pct = (s - (line.start_time - in_out_fade)) / in_out_fade
			local alpha = Interpolate(pct, "&HFF&", "&H00&")
			l.text = l.text:gsub("{", "{\\alpha"..alpha)
		elseif e > line.end_time then
			local pct = (e - (line.end_time)) / in_out_fade
			local alpha = Interpolate(pct, "&H00&", "&HFF&")
			l.text = l.text:gsub("{", "{\\alpha"..alpha)
		end
		Output(l)
	end

	--sylables effect
		--star sky
	local sky = Rectangle(line.width+400, (line.height*10/8) * 2)
	local stars = ""
	for star_i = 1, 100 do
		local glance = Glance(4, 0, math.randomsteps(6, 12, 2))
		local x_add, y_add = math.random(0, line.width+400), math.random(0, (line.height*10/8) * 2)
		local function pos_setter(x, y)
			local new_x = x + x_add
			local new_y = y + y_add
			return string.format("%d %d", new_x, new_y)
		end
		stars = stars .. glance:gsub("(%d+) (%d+)", pos_setter) .. " "
	end
		--sylable pick
	for s, e, i, n in frames(line.start_time - in_out_fade, line.end_time + in_out_fade, 41.71) do
		for si, syl in ipairs(line.syls) do
			if s >= (line.start_time + syl.start_time) and s <= (line.start_time + syl.end_time) then
				--frame standard data
				l.start_time = s
				l.end_time = e
				local syl_path = GetPath(syl.text, line.styleref)
				syl_path:move(syl.left-200 + 400 * (i / n), line.top+line.height, 0)
				syl_path:split(3)
				local function wave(point)
					point[2] = point[2] + math.sin(point[1]/80) * line.height
				end
				syl_path:filter(wave)
				local syl_pct = (s - (line.start_time + syl.start_time)) / syl.duration
				local x = line.left-200
				local y = line.top + line.height - line.height/8 - syl_pct * (line.height*10/8)
				local alpha = Interpolate(syl_pct, "&HFF&", "&H00&", "curve_up")
				--sky
				l.text = string.format("{\\clip(4,%s)\\1c&H600000&\\alpha%s\\bord0\\pos(%.3f,%.3f)\\an7\\p1}%s",
										syl_path:tostring(), alpha, x, y, sky)
				Output(l)
				--stars
				l.text = string.format("{\\clip(4,%s)\\1c&HFFFFFF&\\3c&HFFFFFF&\\alpha%s\\bord0.5\\blur3\\pos(%.3f,%.3f)\\an7\\p1}%s",
										syl_path:tostring(), alpha, x, y, stars)
				Output(l)
				break
			end
		end
	end
end

function main()
	for li, line in ipairs(lines) do
		if line.styleref.alignment >=7 then
			if line.actor == "w" then
				roumaji_w(line)
			else
				roumaji_m(line)
			end
		end
		ProgressStatus(li / #lines)
	end
	print("Writing output file...")
end

main()
