local colors = Distributor({"&H0000FF&", "&H00FF00&", "&HFF0000&", "&H00FFFF&", "&HFFFF00&", "&HFF00FF&"})

function roumaji(line)
	local l = table.copy(line)
	local pct_infade = 0.5
	local char_infade = pct_infade * line.infade/2
	for ci, char in ipairs(line.chars) do
		if char.text ~= " " then
			local color = colors:get()
			--infade
			l.start_time = line.start_time - line.infade / 2 + line.infade / 2 * (ci/#line.chars) * (1 - pct_infade)
			l.end_time = line.start_time
			l.text = string.format("{\\an2\\move(%.3f,%.3f,%.3f,%.3f,0,%d)\\t(%d,%d,\\fscx%d\\fscy%d)\\t(%d,%d,\\fscx%d\\fscy%d)\\1c%s}%s",
									char.center, -line.styleref.outline, char.center, char.bottom, char_infade/2,
									char_infade/2, char_infade*3/4, line.styleref.scale_x * 1.5, line.styleref.scale_y / 2,
									char_infade*3/4, char_infade, line.styleref.scale_x, line.styleref.scale_y,
									color, char.text)
			Output(l)
			--basic + effect + outfade
			local out_fx
			if line.syls[char.syl_i].inline_fx == "LONG" then
				out_fx = "\\frz360\\fscx0\\fscy0"
			else
				out_fx = "\\fry90"
			end
			l.start_time = line.start_time
			l.end_time = line.end_time + line.outfade/2
			l.text = string.format("{\\an5\\pos(%.3f,%.3f)\\t(%d,%d,\\fscy%d)\\t(%d,%d,\\fscy%d)\\t(%d,%d,%s)\\1c%s}%s",
									char.center, char.middle,
									char.start_time, char.start_time + char.duration/2, line.styleref.scale_y * 1.5,
									char.start_time + char.duration/2, char.end_time, line.styleref.scale_y,
									char.end_time, char.end_time + line.outfade/2, out_fx,
									color, char.text)
			Output(l)
		end
	end
end

function main()
	for li, line in ipairs(lines) do
		roumaji(line)
		ProgressStatus(li / #lines)
	end
	print("Writing output file...")
end

main()
